/*
 * Harbour Project source code:
 *
 * Copyright 2010 Viktor Szakats (vszakats.net/harbour)
 * www - http://harbour-project.org
 *
 */
#include "hbdyn.ch"

STATIC s_hDLL := { => }
STATIC s_mutex := hb_mutexCreate()
#require "hbmisc"
//============================================
PROCEDURE Main()

   Local i := 0
   Local nFlags :=space(10) // -1
   Local tnk
   Local ProcID:=GetCurrentProcessId() 
   Local MemUsage:=GETPROCESSMEMORYINFO(ProcID)[3]
   Local cAux := TIME() + hb_osNewLine() + PADR( 'nFlags', 20 ) + PADL( 'Memory', 20 )+ PADL( 'WorkingSetSize', 20 ) + hb_osNewLine() + REPL( '-', 40 ) + hb_osNewLine()

   hb_cdpSelect( "cp1257" )
   SetMode(25,80)
   cls

   While .T.

      i++

      tnk := nextkey()
      if tnk=27 /// exit on esc pressed
                  exit
      endif
      if tnk>0
                inkey()
      endif

      mmCallDll32( "InternetGetConnectedState", "wininet.dll", @nFlags, 0 )     // without memory leak
	  //mmCallDll32 ( "sndPlaySoundA" , "WINMM.DLL" ,  "sample.wav" , 0 )
      //CallDll32( "InternetGetConnectedState", "wininet.dll", @nFlags, 0 )     // with memory leak
	  
	  
	  
	  memUsage:=GETPROCESSMEMORYINFO(ProcID)[3]
      IF MOD( i, 100 ) == 0
         @ 5,5 SAY hb_NtoS( i )+ '>>'+PADL( hb_NtoS( Memory() ), 20 )+ PADL( hb_NtoS( memUsage ), 20 )
      ENDIF

      IF i > 9999999
         EXIT
      ENDIF

   end

Return

// *---------------------------------------------------------------------------*
// hb_gtsys()
// *---------------------------------------------------------------------------*
PROCEDURE hb_gtsys()

   REQUEST HB_LANG_LT
   REQUEST HB_CODEPAGE_LTWIN

   REQUEST HB_GT_WVT_DEFAULT

RETURN
//============================================================================================
//============== my replacement for testing : source from C_CONTROLMISC.C  & H_CONTROLMISC.PRG  === (kristalist)


// CALLDLL32 to -> mmCALLDLL32 
// source : WITHOUT CORRECTION !!! but formal renaming   HB_DynaCall to mmHB_DynaCall1
//                                                       HB_FUNC( HB_DYNACALL1 ) to HB_FUNC( MMHB_DYNACALL1 )
//                                                       HB_ ...... mmHB_
// Copyright 2002-2014 Roberto Lopez <mail.box.hmg@gmail.com>
// http://sites.google.com/site/hmgweb/

#define MAX_PARAMS   8   
Function mmCALLDLL32()
Local aPass := array(11)
Local aParms := HB_aParams()
Local nParmCnt := HMG_LEN(aParms)
Local i

IF nParmCnt > MAX_PARAMS + 2
    return 0
ENDIF

aPass[1] := aParms[1]
aPass[2] := aParms[2]
aPass[3] := nParmCnt-2
FOR i := 3 TO nParmCnt
    aPass[i+1] := IIF(valtype(aParms[i]) == "C", STRPTR(aParms[i]), aParms[i])
NEXT
Return mmHB_DynaCall1( aPass[1],aPass[2],aPass[3],aPass[4],aPass[5],aPass[6],aPass[7],aPass[8],aPass[9],aPass[10],aPass[11])

#pragma BEGINDUMP

#include "windows.h"
//#include "hbapi.h"

#include "hmg_unicode.h"

#define MAX_PARAMS   8

HMODULE mmHB_DllStore[256];

// HMODULE HB_LoadDll ( TCHAR* );


void      mmHB_UnloadDll (void);


typedef   int (CALLBACK *mmDYNACALL1)(void);
int       mmHB_DynaCall (CHAR*, TCHAR*, int, ...);

HMODULE mmHB_LoadDll (TCHAR *DllName)
{
  static int DllCnt;
  static int RegUnload;
  if (!RegUnload) RegUnload=!atexit(mmHB_UnloadDll);
  DllCnt=(DllCnt+1) & 255;
  FreeLibrary(mmHB_DllStore[DllCnt]);
  return mmHB_DllStore[DllCnt]=LoadLibrary(DllName);
}

/*
HB_FUNC( UNLOADALLDLL )
{
   HB_UnloadDll();
}
*/
void mmHB_UnloadDll (void)
{
  register int i;
  for(i=255;i>=0;i--)
    {
      FreeLibrary(mmHB_DllStore[i]);
    }
}


HB_FUNC( MMHB_DYNACALL1 )
{
   hb_retnl(
           mmHB_DynaCall(
             (CHAR*) hb_parc(1),
             (TCHAR*) HMG_parc(2),
             hb_parnl(3),
             hb_parnl(4),
             hb_parnl(5),
             hb_parnl(6),
             hb_parnl(7),
             hb_parnl(8),
             hb_parnl(9),
             hb_parnl(10),
             hb_parnl(11)
             )
           );
}

int mmHB_DynaCall (CHAR *FuncName, TCHAR *DllName, int nArgs, ...)
{
    register int i;
    HINSTANCE  hInst;
    mmDYNACALL1 lpAddr;
    int arg;
    int result = -2000;
    //int *argtable = (int*)malloc(nArgs * sizeof *argtable);
    int argtable[MAX_PARAMS];
    CHAR buff[256];
    va_list ap;

    hInst=GetModuleHandle(DllName);
    if(hInst==NULL)
    {
        hInst=mmHB_LoadDll(DllName);
    }
    lpAddr=(mmDYNACALL1)GetProcAddress(hInst,FuncName);
    if(lpAddr==NULL)
    {
        sprintf(buff,"%s%s",FuncName,"A");
        lpAddr=(mmDYNACALL1)GetProcAddress(hInst,buff);
    }
    if(lpAddr==NULL)
    {
        sprintf(buff,"%s%s","_",FuncName);
        lpAddr=(mmDYNACALL1)GetProcAddress(hInst,buff);
    }
    if (lpAddr)
    {
        va_start(ap,nArgs);
        for (i=0; i<nArgs;i++)
        {
            arg = va_arg(ap,int);
            argtable[i] = arg;
        }
        
        for (i=nArgs-1;i >=0; i--)
        {
            arg = argtable[i];

#if defined ( _WIN64 )
     __asm__("pushq %0" : : "r" ( (LONG_PTR)(arg) ));
#else
            #if defined( __LCC__ )
               _asm ("pushl %arg")
            #elif defined ( __MINGW32__ )
               __asm__("pushl %0" : : "r" (arg));
            #elif defined( __BCPLUSPLUS__ )
               asm push arg
            #else
               __asm {push arg}
            #endif
#endif
        }
        result = (int)(lpAddr)();
        va_end(ap);
    }
    return result;
}
#pragma ENDDUMP

//--------------
/*
 * Harbour Project source code:
 * DLL access functions
 *
 * Copyright 2005 Vic McClung
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA (or visit the web site http://www.gnu.org/).
 *
 * As a special exception, the Harbour Project gives permission for
 * additional uses of the text contained in its release of Harbour.
 *
 * The exception is that, if you link the Harbour libraries with other
 * files to produce an executable, this does not by itself cause the
 * resulting executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of
 * linking the Harbour library code into it.
 *
 * This exception does not however invalidate any other reasons why
 * the executable file might be covered by the GNU General Public License.
 *
 * This exception applies only to the code released by the Harbour
 * Project under the name Harbour.  If you copy code from other
 * Harbour Project or Free Software Foundation releases into a copy of
 * Harbour, as the General Public License permits, the exception does
 * not apply to the code that you add in this way.  To avoid misleading
 * anyone as to the status of such modified files, you must delete
 * this exception notice from them.
 *
 * If you write modifications of your own for Harbour, it is your choice
 * whether to permit this exception to apply to your modifications.
 * If you do not wish that, delete this exception notice.
 *
 */
